package lsgui.gui;

import javax.swing.JCheckBox;
import lsgui.jna.data.LS2Result;

public class OutputVariantDialog extends javax.swing.JDialog {

    private LS2Result result;
    private JCheckBox[] cbVariants;
    
    public OutputVariantDialog(java.awt.Frame parent, boolean modal,
            String[] variants, LS2Result result) {
        super(parent, modal);
        initComponents();
        this.result = result;
        result.initData(variants.length);
        cbVariants = new JCheckBox[variants.length];
        for (int i = 0; i < variants.length; i++) {
            cbVariants[i] = new JCheckBox(variants[i]);
            pList.add(cbVariants[i]);
        }
        cbVariants[0].setSelected(true);
        getRootPane().setDefaultButton(bOk);
    }
    
    private void selectAll(boolean selected) {
        for (int i = 0; i < cbVariants.length; i++) {
            cbVariants[i].setSelected(selected);
        }
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jScrollPane1 = new javax.swing.JScrollPane();
        pList = new javax.swing.JPanel();
        pBottom = new javax.swing.JPanel();
        jPanel1 = new javax.swing.JPanel();
        bSelectAll = new javax.swing.JButton();
        bSelectNone = new javax.swing.JButton();
        jPanel2 = new javax.swing.JPanel();
        bOk = new javax.swing.JButton();
        bCancel = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Select output variants");
        setResizable(false);

        pList.setLayout(new javax.swing.BoxLayout(pList, javax.swing.BoxLayout.PAGE_AXIS));
        jScrollPane1.setViewportView(pList);

        getContentPane().add(jScrollPane1, java.awt.BorderLayout.CENTER);

        pBottom.setLayout(new java.awt.BorderLayout());

        bSelectAll.setText("Select All");
        bSelectAll.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bSelectAllActionPerformed(evt);
            }
        });
        jPanel1.add(bSelectAll);

        bSelectNone.setText("Deselect All");
        bSelectNone.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bSelectNoneActionPerformed(evt);
            }
        });
        jPanel1.add(bSelectNone);

        pBottom.add(jPanel1, java.awt.BorderLayout.NORTH);

        bOk.setText("Ok");
        bOk.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bOkActionPerformed(evt);
            }
        });
        jPanel2.add(bOk);

        bCancel.setText("Cancel");
        bCancel.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bCancelActionPerformed(evt);
            }
        });
        jPanel2.add(bCancel);

        pBottom.add(jPanel2, java.awt.BorderLayout.SOUTH);

        getContentPane().add(pBottom, java.awt.BorderLayout.SOUTH);

        java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        setBounds((screenSize.width-350)/2, (screenSize.height-360)/2, 350, 360);
    }// </editor-fold>//GEN-END:initComponents

    private void bCancelActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bCancelActionPerformed
        dispose();
    }//GEN-LAST:event_bCancelActionPerformed

    private void bOkActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bOkActionPerformed
        for (int i = 0; i < cbVariants.length; i++) {
            if (cbVariants[i].isSelected()) {
                result.initDataAt(i);
            }
        }
        dispose();
    }//GEN-LAST:event_bOkActionPerformed

    private void bSelectAllActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bSelectAllActionPerformed
        selectAll(true);
    }//GEN-LAST:event_bSelectAllActionPerformed

    private void bSelectNoneActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bSelectNoneActionPerformed
        selectAll(false);
    }//GEN-LAST:event_bSelectNoneActionPerformed

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton bCancel;
    private javax.swing.JButton bOk;
    private javax.swing.JButton bSelectAll;
    private javax.swing.JButton bSelectNone;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JPanel pBottom;
    private javax.swing.JPanel pList;
    // End of variables declaration//GEN-END:variables
}
