package lsgui.gui;

import javax.swing.DefaultListModel;
import latmath.algorithm.BasicLaterationAlgorithm;

public class VerifyDialog extends javax.swing.JDialog {

    private BasicLaterationAlgorithm selected;
    
    public VerifyDialog(java.awt.Frame parent, boolean modal, String algorithm,
            BasicLaterationAlgorithm[] algorithms) {
        super(parent, modal);
        initComponents();
        
        DefaultListModel model = new DefaultListModel();
        for (int i = 0; i < algorithms.length; i++) {
            model.addElement(algorithms[i]);
        }
        algorithmList.setModel(model);
        
        BasicLaterationAlgorithm found = null;
        for (int i = 0; i < algorithms.length; i++) {
            String s = algorithms[i].getName();
            if (s.equalsIgnoreCase(algorithm) || algorithm.toLowerCase().contains(s.toLowerCase())) {
                found = algorithms[i];
                break;
            }
        }
        
        if (found != null) {
            algorithmList.setSelectedValue(found, true);
        }
    }
    
    public BasicLaterationAlgorithm getSelectedAlgorithm() {
        return selected;
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        pMain = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        algorithmList = new javax.swing.JList();
        pRight = new javax.swing.JPanel();
        jPanel1 = new javax.swing.JPanel();
        bConfigure = new javax.swing.JButton();
        jPanel2 = new javax.swing.JPanel();
        pBottom = new javax.swing.JPanel();
        bOk = new javax.swing.JButton();
        bCancel = new javax.swing.JButton();
        pTop = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Configure Verify");
        setResizable(false);

        pMain.setBorder(javax.swing.BorderFactory.createEmptyBorder(10, 10, 10, 5));
        pMain.setLayout(new java.awt.BorderLayout());

        algorithmList.setSelectionMode(javax.swing.ListSelectionModel.SINGLE_SELECTION);
        algorithmList.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                algorithmListMouseClicked(evt);
            }
        });
        algorithmList.addListSelectionListener(new javax.swing.event.ListSelectionListener() {
            public void valueChanged(javax.swing.event.ListSelectionEvent evt) {
                algorithmListValueChanged(evt);
            }
        });
        jScrollPane1.setViewportView(algorithmList);

        pMain.add(jScrollPane1, java.awt.BorderLayout.CENTER);

        getContentPane().add(pMain, java.awt.BorderLayout.CENTER);

        pRight.setBorder(javax.swing.BorderFactory.createEmptyBorder(10, 0, 0, 10));
        pRight.setLayout(new java.awt.BorderLayout());

        jPanel1.setLayout(new javax.swing.BoxLayout(jPanel1, javax.swing.BoxLayout.PAGE_AXIS));

        bConfigure.setText("Configure...");
        bConfigure.setEnabled(false);
        bConfigure.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bConfigureActionPerformed(evt);
            }
        });
        jPanel1.add(bConfigure);
        jPanel1.add(jPanel2);

        pRight.add(jPanel1, java.awt.BorderLayout.NORTH);

        getContentPane().add(pRight, java.awt.BorderLayout.EAST);

        bOk.setText("Ok");
        bOk.setEnabled(false);
        bOk.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bOkActionPerformed(evt);
            }
        });
        pBottom.add(bOk);

        bCancel.setText("Cancel");
        bCancel.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bCancelActionPerformed(evt);
            }
        });
        pBottom.add(bCancel);

        getContentPane().add(pBottom, java.awt.BorderLayout.SOUTH);

        pTop.setBorder(javax.swing.BorderFactory.createEmptyBorder(10, 10, 1, 10));
        pTop.setPreferredSize(new java.awt.Dimension(416, 65));
        pTop.setLayout(new java.awt.BorderLayout());

        jLabel1.setText("<html>Please select an algorithm from the latmath package to start the verification process.</html>");
        pTop.add(jLabel1, java.awt.BorderLayout.CENTER);

        getContentPane().add(pTop, java.awt.BorderLayout.NORTH);

        java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        setBounds((screenSize.width-468)/2, (screenSize.height-494)/2, 468, 494);
    }// </editor-fold>//GEN-END:initComponents

    private void bCancelActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bCancelActionPerformed
        selected = null;
        dispose();
    }//GEN-LAST:event_bCancelActionPerformed

    private void algorithmListValueChanged(javax.swing.event.ListSelectionEvent evt) {//GEN-FIRST:event_algorithmListValueChanged
        if (!evt.getValueIsAdjusting()) {
            BasicLaterationAlgorithm algorithm = (BasicLaterationAlgorithm)
                    algorithmList.getSelectedValue();
            bOk.setEnabled(algorithm != null);
            bConfigure.setEnabled(algorithm != null && algorithm.isConfigurable());
        }
    }//GEN-LAST:event_algorithmListValueChanged

    private void bOkActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bOkActionPerformed
        selected = (BasicLaterationAlgorithm) algorithmList.getSelectedValue();
        dispose();
    }//GEN-LAST:event_bOkActionPerformed

    private void bConfigureActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bConfigureActionPerformed
        BasicLaterationAlgorithm algorithm = (BasicLaterationAlgorithm)
                    algorithmList.getSelectedValue();
        if (algorithm != null && algorithm.isConfigurable()) {
            algorithm.configure((java.awt.Frame)getParent());
            algorithmList.repaint();
        }
    }//GEN-LAST:event_bConfigureActionPerformed

    private void algorithmListMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_algorithmListMouseClicked
        if (evt.getClickCount() == 2) {
            if (bOk.isEnabled()) {
                bOk.doClick();
            }
        }
    }//GEN-LAST:event_algorithmListMouseClicked

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JList algorithmList;
    private javax.swing.JButton bCancel;
    private javax.swing.JButton bConfigure;
    private javax.swing.JButton bOk;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JPanel pBottom;
    private javax.swing.JPanel pMain;
    private javax.swing.JPanel pRight;
    private javax.swing.JPanel pTop;
    // End of variables declaration//GEN-END:variables
}
